/******************************************************************************
Filename:     modBuzzerImpl.c
Target:       cc2530

Description:
ṩһּ򵥵ķƺʵ֡

Ӳ1P1_3, ߵƽ졣

modification:
2014.11.09 creation

COPYRIGHT
Zheng Hui, Guangzhou, China. hzheng@gzhu.edu.cn. Guangzhou University

******************************************************************************/
#include "modBuzzer.h"
#include <ioCC2530.h>


#define BUZZER         P1_3
#define BUZZER_ON      1
#define BUZZER_OFF     0

/**
 * ʼӿ
 */
int8 modBuzzerInit(){
  BUZZER = BUZZER_OFF;
  P1DIR = P1DIR|0x08;
  P1SEL =P1SEL&0x0F7;
  return 0;
}

/**
 * ״̬ýӿ
 * 
 *       vBuzzerState: 0 = off, 1 = on, 2 = toggle
 * return:
 *       0=success,  -2 = unsupported vBuzzerState
 */
int8 modSetBuzzerState(uint8 vBuzzerState) {
  if (vBuzzerState >2) {
    return -2;
  }
  if (vBuzzerState == 0) {
    BUZZER = BUZZER_OFF;
  }else if (vBuzzerState == 1) {
    BUZZER = BUZZER_ON;
  }else {
    BUZZER = !BUZZER;
  }
  return 0;
}  