
/*+**********************************************************************************
  Filename: main.c

  Description:
  ںѧϰ̡

  cѧϰ顢ָ

  Modification:
    2014.11.12 creation by Zheng Hui

**********************************************************************************-*/
#include "modSys.h"
#include "modHwExt.h"
#include "modTimer.h"
#include "modUart.h"

/**
 * ò
 */
#define DELAY_PERIOD1 5000
#define UART_MSG_LEN 4
/**
 * ȫֱ
 */
//for timer task
uint8 mTimeoutIndex1 = 0;
uint8 mTimeoutFlag1 = 0;

//for uart
uint8* mpUartRxBuffer;
uint8 mUartRxPktSize = 0;
uint8 mUartTxBuffer[10];
uint8 mMsgIndex = 0;

/**
 * 
 */
void init();
int8 myTimeoutCallback1(uint8 vCallbackIndex); //ʱص
void myUartRxCallbackFunction(uint8 vUartNumber, uint8 vSize, uint8* vPacket); //Uart Rx Callback
void sendUartMsg();

/**
 * 
 */
void main(void) {
 //ʼ
  init();

  //ѭ
  while (1) {
    if (mTimeoutFlag1>0) {
      mTimeoutFlag1 =0;
      sendUartMsg();
    }
    if (mUartRxPktSize>0) {
      modSetLedState(mpUartRxBuffer[0], mpUartRxBuffer[1]); //control led according to incoming message data
      mUartRxPktSize =0;
    }
  }

}

/**
 * ʼ
 */
void init(){
  modMcuInit();
  modLedInit();
  //ʱʼ
  modTimerInit();
  modTimerAddTimeoutCallback(DELAY_PERIOD1, myTimeoutCallback1, 1, &mTimeoutIndex1);
  //UART init
  modUartInit(0,115200);
  modUartSetRxCallback(myUartRxCallbackFunction);
  //init msg data
  mUartTxBuffer[1]=0x30;
  mUartTxBuffer[2]=0x41;
  mUartTxBuffer[3]=0x61;
}

/**
 * timeout Callback
 */
int8 myTimeoutCallback1(uint8 vCallbackIndex) {
  mTimeoutFlag1 = 1; //indicate main loop to do timeout task
  return 0;
}

/**
 * ڽջص
 */
void myUartRxCallbackFunction(uint8 vUartNumber, uint8 vSize, uint8* vPacket){
  //save packet pointer
  mpUartRxBuffer = vPacket;
  //mUartRxPktSizeΪ־
  mUartRxPktSize = vSize;

}

/**
 * ʹϢ
 */
void sendUartMsg(){
  mMsgIndex ++;
  mUartTxBuffer[0]= mMsgIndex;
  modUartSendPkt(0,UART_MSG_LEN,mUartTxBuffer);
}
