/******************************************************************************
Filename:     modButtonImpl.c
Target:       cc2530

Description:
ṩһּ򵥵İѯʵ֡

Ӳ2P0_4, P0_5δʱΪߵƽ

modification:
2014.11.03 creation

COPYRIGHT
Zheng Hui, Guangzhou, China. hzheng@gzhu.edu.cn. Guangzhou University

******************************************************************************/
#include "modHwExt.h"
#include "modSys.h"

#include <ioCC2530.h>


#define BUTTON1          P0_4
#define BUTTON2          P0_5
#define BUTTON_DOWN      0
#define BUTTON_UP        1

#define DEBOUNCE_PERIOD 100

/**
 * buttonʼӿ
 */
int8 modButtonInit(){
  P0DIR = P0DIR&0x0cf; //set input mode, clear bit 4 and 5
  P0SEL = P0SEL&0x0cf; //set normal i/o mode.
  P0INP &= 0x0cf; //set P0_4, P0_5 pull up mode.
  P2INP &= 0x0df; //set PORT0 pull up mode.
  return 0;
}

/**
 * ѯӿ
 * 
 *       
 * return:
 *   0: ûа²ɿ
 *   1-- n : n²ɿ
 * ͣ
 *   PushedȻɿֻǰ£downֻɿup
 * Ϊ
 *   ʱѯûа£򷵻0
 *   ĳ£ȴһζʱȷԱ£ȻȴɿظðӦID
 *   ж£ֻӦǰİ
 */
int8 modGetButtonPushed() {
  if (BUTTON1 == BUTTON_DOWN) {
    //wait a little while
    modDelay(DEBOUNCE_PERIOD);
    //check again
    if (BUTTON1 == BUTTON_DOWN) {
      //wait for release
      while (BUTTON1 == BUTTON_DOWN) {
      }
      //return with button id
      return 1;
    }
  }
  if (BUTTON2 == BUTTON_DOWN) {
    //wait a little while
    modDelay(DEBOUNCE_PERIOD);
    //check again
    if (BUTTON2 == BUTTON_DOWN) {
      //wait for release
      while (BUTTON2 == BUTTON_DOWN) {
      }
      //return with button id
      return 2;
    }    
  }
  return 0;
  
}

