/******************************************************************************
Filename:     modHwExt.h
Description:
H.Zheng common building block layer module library: hardware extention part

modification:
  2008.1.14 creation Zheng Hui
  2012.04.15 renew structure and contents.
  2014.11.03 add button function

COPYRIGHT
Zheng Hui, Guangzhou, China. 

******************************************************************************/
#ifndef MOD_HWEXT_H
#define MOD_HWEXT_H

#include "modTypes.h"

//
// עķֵѭmodTypes.hеĶ壺0Ϊɹ<0Ϊʧܣ-4Ϊֵֻ֧򱾺δʵ֡
//

//
//LEDؽӿ
//
/**
 * LEDʼӿ
 * עLEDĿӦӲء
 */
int8 modLedInit();

/**
 * LED״̬ýӿ
 * Set specified LED to specified state.
 * 
 *       vLedId: 0-n
 *       vLedState: 0 = off, 1 = on, 2 = toggle
 * return:
 *       0=success, -1 = unsupported vLedId, -2 = unsupported vLedState
 */
int8 modSetLedState(uint8 vLedId, uint8 vLedState);

//ؽӿ
/**
 * ʼӿ
 * עĿӦӲء
 */
int8 modButtonInit();

/**
 * ѯӿ
 * 
 *       
 * return:
 *   0: ûа²ɿ
 *   1-- n : n²ɿ
 * ͣ
 *   PushedȻɿֻǰ£downֻɿup
 * Ϊ
 *   ʱѯûа£򷵻0
 *   ĳ£ȴһζʱȷԱ£ȻȴɿظðӦID
 *   ж£ֻӦǰİ
 */
int8 modGetButtonPushed();


#endif  // MOD_HWEXT_H
