/******************************************************************************
Filename:     modTimer.h
Description:
H.Zheng MCU common building block layer module library: Timer part

ӦÿͨӿӶʱ

modification:
  2012.06.20 creation Zheng Hui
  2014.03.31 modify modTimerAddTimeoutCallback() definition, change vNumOfMs
             to vNumOfOverflows

COPYRIGHT
Zheng Hui, Guangzhou, China.

******************************************************************************/
#ifndef MOD_TIMER_H
#define MOD_TIMER_H

#include "modTypes.h"

//
// עķֵѭmodTypes.hеĶ壺0Ϊɹ<0Ϊʧܣ-4Ϊֵֻ֧򱾺δʵ֡
//
/**
 * ͬʱӼֵ
 * Timer3ÿoverflowжһΣ1ms1
 */
extern uint32 gNetSyncTimerCounter;

/**
 * ϵͳʱʼӿ
 */
int8 modTimerInit();

/**
 * ʱص
 * 
 *     vCallbackIndex: ʾûصõľmodTimerAddTimeoutCallbackṩӦá
 * ֵ
 *     νݲ
 */
typedef int8 modTimerTimeoutCallbackFunction(uint8 vCallbackIndex);

/**
 * Ӷʱصӿ
 * 
 *     vNumOfOverflows: ٴжϵһλصһʱʵִ
 *     vFunction: صָ
 *     vRepeatFlag: Ƿظ0ʾظ=0ʾֻصһ
 * 
 *     vCallbackIndex: ʾûصõľȡص
 */
int8 modTimerAddTimeoutCallback(uint16 vNumOfOverflows, modTimerTimeoutCallbackFunction* vFunction, uint8 vRepeatFlag, uint8* vCallbackIndex );

/**
 * ȡʱصӿ
 * 
 *     vCallbackIndex: ʾûصõľmodTimerAddTimeoutCallbackṩӦá
 */
int8 modTimerRemoveTimeoutCallback(uint8 vCallbackIndex);


#endif  // MOD_TIMER_H
